

   MEMBER('PEOPLE.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABQUERY.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('PEOPL003.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('PEOPL004.INC'),ONCE        !Req'd for module callout resolution
                     END


BrowseSiteUse PROCEDURE                                    ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(SiteUse)
                       PROJECT(STU:recd_nbr)
                       PROJECT(STU:PersonID)
                       PROJECT(STU:DateUsed)
                       PROJECT(STU:TimeStart)
                       PROJECT(STU:Activity)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
STU:recd_nbr           LIKE(STU:recd_nbr)             !List box control field - type derived from field
STU:PersonID           LIKE(STU:PersonID)             !List box control field - type derived from field
STU:DateUsed           LIKE(STU:DateUsed)             !List box control field - type derived from field
STU:TimeStart          LIKE(STU:TimeStart)            !List box control field - type derived from field
STU:Activity           LIKE(STU:Activity)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the SiteUse file'),AT(,,450,265),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM,HLP('BrowseSiteUse'),SYSTEM,GRAY,RESIZE,MDI
                       BUTTON('&Query'),AT(170,0,50,17),USE(?Query),FLAT,LEFT,ICON('SQBE.ICO')
                       LIST,AT(8,30,426,181),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing  SiteUse'),FORMAT('44D(12)|M~recd nbr~C(0)@n10.2@80R(2)|M~Person ID~C(0)@n020@80R(2)|M~Date Used~C(' &|
         '0)@D8@80R(2)|M~Time Start~C(0)@t3@80L(2)|M~Activity~@s50@'),FROM(Queue:Browse:1)
                       PROMPT('Person:'),AT(13,221),USE(?PEO:FirstName:Prompt)
                       ENTRY(@S30),AT(43,221,60,10),USE(PEO:FirstName),SKIP,COLOR(0BBF3FBH),READONLY
                       ENTRY(@S30),AT(107,221,143,10),USE(PEO:LastName),SKIP,COLOR(0BBF3FBH),READONLY
                       PROMPT('Filter:'),AT(11,234),USE(?Glo:FilterStrg:Prompt)
                       ENTRY(@s250),AT(43,233,396,10),USE(Glo:FilterStrg),SKIP,COLOR(COLOR:Silver),READONLY
                       BUTTON('&View'),AT(43,244,50,17),USE(?View:2),FLAT,LEFT,MSG('View Record'),TIP('View Record'),ICON('WAVIEW.ICO')
                       BUTTON('&Insert'),AT(97,244,50,17),USE(?Insert:3),FLAT,LEFT,MSG('Insert a Record'),TIP('Insert a Record'),ICON('WAINSERT.ICO')
                       BUTTON('&Change'),AT(151,244,50,17),USE(?Change:3),FLAT,LEFT,MSG('Change the Record'),TIP('Change the Record'),ICON('WACHANGE.ICO'),DEFAULT
                       BUTTON('&Delete'),AT(205,244,50,17),USE(?Delete:3),FLAT,LEFT,MSG('Delete the Record'),TIP('Delete the Record'),ICON('WADELETE.ICO')
                       SHEET,AT(4,4,437,212),USE(?CurrentTab)
                         TAB('by &Record Nbr'),USE(?Tab:2)
                         END
                         TAB('by &Date'),USE(?Tab:3)
                         END
                         TAB('by &PersonID'),USE(?Tab:4)
                         END
                       END
                       BUTTON('&Close'),AT(390,247,50,17),USE(?Close),FLAT,LEFT,MSG('Close Window'),TIP('Close Window'),ICON('WACLOSE.ICO')
                       BUTTON('&Help'),AT(311,247,50,17),USE(?Help),FLAT,LEFT,MSG('See Help Window'),TIP('See Help Window'),ICON('WAHELP.ICO'),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

Toolbar              ToolbarClass
QBE8                 QueryListClass                        ! QBE List Class. 
QBV8                 QueryListVisual                       ! QBE Visual Class
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
TakeNewSelection       PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort0:StepClass StepRealClass                        ! Default Step Manager
BRW1::Sort1:StepClass StepLongClass                        ! Conditional Step Manager - CHOICE(?CurrentTab) = 2
BRW1::Sort2:StepClass StepLongClass                        ! Conditional Step Manager - CHOICE(?CurrentTab) = 3
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(people:Record)
? DEBUGHOOK(SiteUse:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseSiteUse')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Query
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  Glo:FilterStrg = 'UPPER(STU:DateUsed),,>='&format(Glo:CurrentDate,@D8)&','
  IF ~INIMgr.TryFetch('Query','BrwsUsage$TodayOnly$$Query')
      IF ~INIMgr.TryFetch('__Dont_Touch_Me__','Sectors_1')   
         !want 1st to be tsMRU system default
        INIMgr.Update('__Dont_Touch_Me__','Sectors_1','BrwsUsage,tsMRU,Query')    
        INIMgr.Update('Query','BrowseSiteUse$tsMRU$$Query',3)
        INIMgr.Update('Query','BrowseSiteUse$tsMRU$$Query_1',Glo:FilterStrg)
        INIMgr.Update('Query','BrowseSiteUse$tsMRU$$Query_2','UPPER(STU:TIMESTART),,,')
        INIMgr.Update('Query','BrowseSiteUse$tsMRU$$Query_3','UPPER(STU:ACTIVITY),,,')
      .
      INIMgr.Update('__Dont_Touch_Me__','Sectors_2','BrowseSiteUse,TodayOnly,Query')
      INIMgr.Update('Query','BrowseSiteUse$TodayOnly$$Query',3)
      INIMgr.Update('Query','BrowseSiteUse$TodayOnly$$Query_1',Glo:FilterStrg)
      INIMgr.Update('Query','BrowseSiteUse$TodayOnly$$Query_2','UPPER(STU:TIMESTART),,,')
      INIMgr.Update('Query','BrowseSiteUse$TodayOnly$$Query_3','UPPER(STU:ACTIVITY),,,')
  ELSE
        !this will update the date in the INI for each time the Query is used thereafter
      INIMgr.Update('Query','BrowseSiteUse$TodayOnly$$Query_1',Glo:FilterStrg)
  .
  Glo:FilterStrg=''
  Glo:FilterStrg='UPPER(STU:DateUsed),='&format(GLO:CurrentDate-1,@D8)&',,'
  IF ~INIMgr.TryFetch('Query','BrowseSiteUse$TimeRange$$Query')
      INIMgr.Update('__Dont_Touch_Me__','Sectors_3','BrowseSiteUse,TimeRange,Query')
      INIMgr.Update('Query','BrowseSiteUse$TimeRange$$Query',3)
      INIMgr.Update('Query','BrowseSiteUse$TimeRange$$Query_1',Glo:FilterStrg)
      INIMgr.Update('Query','BrowseSiteUse$TimeRange$$Query_2','UPPER(STU:TIMESTART),,>=10:00AM,<=2:30PM')
      INIMgr.Update('Query','BrowseSiteUse$TimeRange$$Query_3','UPPER(STU:ACTIVITY),,,')
  ELSE
      !this will update the date in the INI
      INIMgr.Update('Query','BrowseSiteUse$TimeRange$$Query_1',Glo:FilterStrg)
  .
  Glo:FilterStrg=''
  Glo:FilterStrg='UPPER(STU:DateUsed),='&format(GLO:CurrentDate-1,@D8)&',,'
  IF ~INIMgr.TryFetch('Query','BrowseSiteUse$ActivityType$$Query')
      INIMgr.Update('__Dont_Touch_Me__','Sectors_4','BrowseSiteUse,ActivityType,Query')
      INIMgr.Update('Query','BrowseSiteUse$ActivityType$$Query',3)
      INIMgr.Update('Query','BrowseSiteUse$ActivityType$$Query_1',Glo:FilterStrg)
      INIMgr.Update('Query','BrowseSiteUse$ActivityType$$Query_2','UPPER(STU:TIMESTART),,,')
      INIMgr.Update('Query','BrowseSiteUse$ActivityType$$Query_3','UPPER(STU:ACTIVITY),GEN*,,')
  ELSE
      !this will update the date in the INI
      INIMgr.Update('Query','BrowseSiteUse$ActivityType$$Query_1',Glo:FilterStrg)
  END
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:people.Open                                       ! File people used by this procedure, so make sure it's RelationManager is open
  Relate:SiteUse.Open                                      ! File SiteUse used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:SiteUse,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  QBE8.Init(QBV8, INIMgr,'BrowseSiteUse', GlobalErrors)
  QBE8.QkSupport = True
  QBE8.QkMenuIcon = 'QkQBE.ico'
  QBE8.QkIcon = 'QkLoad.ico'
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon STU:DateUsed for sort order 1
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,STU:k_Date)      ! Add the sort order for STU:k_Date for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,STU:DateUsed,1,BRW1)           ! Initialize the browse locator using  using key: STU:k_Date , STU:DateUsed
  BRW1::Sort2:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon STU:PersonID for sort order 2
  BRW1.AddSortOrder(BRW1::Sort2:StepClass,STU:k_PersonID)  ! Add the sort order for STU:k_PersonID for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,STU:PersonID,1,BRW1)           ! Initialize the browse locator using  using key: STU:k_PersonID , STU:PersonID
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)       ! Moveable thumb based upon STU:recd_nbr for sort order 3
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,STU:k_Recd_nbr)  ! Add the sort order for STU:k_Recd_nbr for sort order 3
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort0:Locator.Init(,STU:recd_nbr,1,BRW1)           ! Initialize the browse locator using  using key: STU:k_Recd_nbr , STU:recd_nbr
  BRW1.AddField(STU:recd_nbr,BRW1.Q.STU:recd_nbr)          ! Field STU:recd_nbr is a hot field or requires assignment from browse
  BRW1.AddField(STU:PersonID,BRW1.Q.STU:PersonID)          ! Field STU:PersonID is a hot field or requires assignment from browse
  BRW1.AddField(STU:DateUsed,BRW1.Q.STU:DateUsed)          ! Field STU:DateUsed is a hot field or requires assignment from browse
  BRW1.AddField(STU:TimeStart,BRW1.Q.STU:TimeStart)        ! Field STU:TimeStart is a hot field or requires assignment from browse
  BRW1.AddField(STU:Activity,BRW1.Q.STU:Activity)          ! Field STU:Activity is a hot field or requires assignment from browse
  BRW1.QueryControl = ?Query
  BRW1.Query &= QBE8
  QBE8.AddItem('UPPER(STU:DateUsed)','DateUsed','@D8',1)
  QBE8.AddItem('UPPER(STU:TimeStart)','TimeStart','@t3',1)
  QBE8.AddItem('UPPER(STU:Activity)','Activity','@s50',1)
  BRW1.AskProcedure = 1
     BRW1.Query.Restore('TimeRange')
     BRW1.Query.Save('TimeRange')
     BRW1.Query.Restore('TodayOnly')
     BRW1.Query.Save('TodayOnly')
     BRW1.Query.Restore('ActivityType')
     BRW1.Query.Save('ActivityType')
  
  SELF.SetAlerts()
  BRW1.TakeLocate
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:people.Close
    Relate:SiteUse.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateSiteUse
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.QueryShared = 1
  SELF.QueryResult = ?Glo:FilterStrg
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSE
    RETURN SELF.SetSort(3,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


BRW1.TakeNewSelection PROCEDURE

  CODE
  PARENT.TakeNewSelection
  PEO:Id=STU:PersonID
  Case Access:People.TryFetch(PEO:KeyId)
  OF Level:Benign
  ELSE
     PEO:LastName = ''
     PEO:FirstName= 'Not Found'
  END
  display(?PEO:FirstName,?PEO:LastName)


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves=False
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

