!============================================================
! sdkLCS.inc -- List Column Sorter class implementation
!
!  2010 Simon Kemp, simon@sdk.demon.co.uk
!
!  This software is provided 'as-is', without any express or implied
!  warranty.  In no event will the author be held liable for any damages
!  arising from the use of this software.
!
!  Permission is granted to anyone to use this software for any purpose,
!  including commercial applications, and to alter it and redistribute it
!  freely, subject to the following restrictions:
!
!  1. The origin of this software must not be misrepresented; you must not
!     claim that you wrote the original software. If you use this software
!     in a product, an acknowledgment in the product documentation would be
!     appreciated but is not required.
!
!  2. Altered source versions must be plainly marked as such, and must not be
!     misrepresented as being the original software.
!
!  3. This notice may not be removed or altered from any source distribution.
!
!============================================================
sdkLCScolq      queue,type
column            long
columnwho         string(100)
headertext        string(255)
sortoptions       long
fieldno           long
isastring         long
                end

sdkLCSkeyq      queue,type
level             long
column            long
direction         long
fieldno           long
sortoptions       long
isastring         long
                end

sdkLCS      class,type

Init                procedure(long thelistfeq, *queue listqueue, long tweaklineheight=0)
Kill                procedure
SetColumnOptions    procedure(<string nosorting>, <string casesensitive>, <string restrictsort>)
SetInitialSort      procedure(<*string variablesort>, <string initialsort>, long locked=0)
Start               procedure

ShowHeaders         procedure
ShowSort            procedure,string
Sort                procedure
TakeEvent           procedure

Construct           procedure,private
Destruct            procedure,private

alertkeystd         long,private
alertkeymulti       long,private
alertkeyclear       long,private
blockcolumnoptions  long,private
columns             &sdkLCScolq,private
initialsort         string(100),private
keys                &sdkLCSkeyq,private
listfeq             long,private
listfrom            &queue,private
locked              long,private
stickysort          &string,private
storechanges        long,private

multikey            long
prependindicators   long
showcursoronsort    long
sortonchanges       long

            end
